## vimb 3.7.0+git20240706

=== Makefile ===
version = 3.7.0
include config.mk

all: version.h src.subdir-all

version.h: Makefile $(wildcard .git/index)
	@echo "create $@"
	$(Q)v="$$(git describe --tags 2>/dev/null)"; \
	echo "#define VERSION \"$${v:-$(version)}\"" > $@

options:
	@echo "vimb build options:"
	@echo "LIBS      = $(LIBS)"
	@echo "CFLAGS    = $(CFLAGS)"
	@echo "LDFLAGS   = $(LDFLAGS)"
	@echo "EXTCFLAGS = $(EXTCFLAGS)"
	@echo "CC        = $(CC)"

install: all
	@# binary
	install -d $(BINPREFIX)
	install -m 755 src/vimb $(BINPREFIX)/vimb
	@# extension
	install -d $(LIBDIR)
	install -m 644 src/webextension/$(EXTTARGET) $(LIBDIR)/$(EXTTARGET)
	@# man page
	install -d $(MANPREFIX)/man1
	@sed -e "s!VERSION!$(version)!g" \
		-e "s!PREFIX!$(PREFIX)!g" \
		-e "s!DATE!`date -u -r $(DOCDIR)/vimb.1 +'%m %Y' 2>/dev/null || date +'%m %Y'`!g" $(DOCDIR)/vimb.1 > $(MANPREFIX)/man1/vimb.1
	@# .desktop file
	install -d $(DOTDESKTOPPREFIX)
	install -m 644 vimb.desktop $(DOTDESKTOPPREFIX)/vimb.desktop
	@# .metainfo.xml file
	install -d $(METAINFOPREFIX)
	install -m 644 vimb.metainfo.xml $(METAINFOPREFIX)/vimb.metainfo.xml

uninstall:
	$(RM) $(BINPREFIX)/vimb
	$(RM) $(DESTDIR)$(MANDIR)/man1/vimb.1
	$(RM) $(LIBDIR)/$(EXTTARGET)
	$(RM) $(DOTDESKTOPPREFIX)/vimb.desktop
	$(RM) $(METAINFOPREFIX)/vimb.metainfo.xml

clean: src.subdir-clean test-clean

sandbox:
	$(Q)$(MAKE) RUNPREFIX=$(CURDIR)/sandbox/usr PREFIX=/usr DESTDIR=./sandbox install

runsandbox: sandbox
	sandbox/usr/bin/vimb

test: version.h
	$(MAKE) -C src vimb.so
	$(MAKE) -C tests

test-clean:
	$(MAKE) -C tests clean

%.subdir-all:
	$(Q)$(MAKE) -C $*

%.subdir-clean:
	$(Q)$(MAKE) -C $* clean

.PHONY: all options install uninstall clean sandbox runsandbox

=== src/Makefile ===
include ../config.mk

OBJ = $(patsubst %.c, %.o, $(wildcard *.c))
JSFILES  = $(wildcard scripts/*.js)
CSSFILES = $(wildcard scripts/*.css)

all: vimb webextension.subdir-all

clean: webextension.subdir-clean
	$(RM) vimb vimb.so $(OBJ)
	$(RM) scripts/scripts.h

vimb: $(OBJ)
	@echo "${CC} $@"
	$(Q)$(CC) $(OBJ) $(LDFLAGS) -o $@

vimb.so: $(OBJ)
	$(Q)$(CC) -shared $(OBJ) $(LDFLAGS) -o $@

$(OBJ): config.h ../config.mk

main.o: ../version.h

input.o: scripts/scripts.h

normal.o: scripts/scripts.h

setting.o: scripts/scripts.h

scripts/scripts.h: $(JSFILES) $(CSSFILES)
	$(Q)$(RM) $@
	@echo "create $@ from *.{css,js}"
	$(Q)for file in $(JSFILES) $(CSSFILES); do \
		./scripts/js2h.sh $$file >> $@; \
	done

config.h:
	@echo create $@ from config.def.h
	$(Q)cp config.def.h $@

%.o: %.c
	@echo "${CC} $@"
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

%.subdir-all: config.h
	$(Q)$(MAKE) -C $*

%.subdir-clean:
	$(Q)$(MAKE) -C $* clean

-include $(OBJ:.o=.d)

.PHONY: all clean

=== tests/Makefile ===
CPPFLAGS = -I ../

include ../config.mk

TEST_PROGS = test-util \
			 test-shortcut \
			 test-handler \
			 test-file-storage

all: $(TEST_PROGS)
	$(Q)LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):." gtester --verbose $(TEST_PROGS)

${TEST_PROGS}: ../$(SRCDIR)/vimb.so

test-%: test-%.c
	@echo "${CC} $@"
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< ../$(SRCDIR)/vimb.so $(LDFLAGS)

clean:
	$(RM) $(TEST_PROGS)

=== src/webextension/Makefile ===
include ../../config.mk

OBJ = $(patsubst %.c, %.lo, $(wildcard *.c))

all: $(EXTTARGET)

clean:
	$(RM) $(EXTTARGET) $(OBJ)

$(EXTTARGET): $(OBJ)
	@echo "$(CC) $@"
	$(Q)$(CC) $(OBJ) $(EXTLDFLAGS) -o $@

%.lo: %.c
	@echo "${CC} $@"
	$(Q)$(CC) $(EXTCPPFLAGS) $(EXTCFLAGS) -fPIC -c -o $@ $<

-include $(OBJ:.lo=.d)

.PHONY: all clean

=== debian/changelog ===
vimb (3.7.0+git20240706-1) unstable; urgency=medium

  * Initial release to Debian. (Closes: #982010)

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Wed, 24 Jul 2024 18:54:15 +0200

=== debian/control ===
Source: vimb
Section: misc
Priority: optional
Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
Build-Depends: debhelper-compat (= 13), libsoup-3.0-dev, libwebkit2gtk-4.1-dev, libgtk-3-dev, libglib2.0-dev
Standards-Version: 4.7.0
Homepage: https://fanglingsu.github.io/vimb/
Vcs-Browser: https://github.com/mati75/vimb
Vcs-Git: https://github.com/mati75/vimb
Rules-Requires-Root: no

Package: vimb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: www-browser
Description: Light-weight webkit-based browser with vim keyboard bindings
 Vimb is a Vim-like web browser that is inspired by Pentadactyl
 and Vimprobable. The goal of Vimb is to build a completely
 keyboard-driven, efficient and pleasurable browsing-experience
 with low memory and CPU usage that is intuitive to use for Vim
 users.

=== debian/rules ===
#!/usr/bin/make -f

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEB_BUILD_MAINT_OPTIONS += hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PREFIX=/usr

%:
	dh $@

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/fanglingsu/vimb/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@

## vimb 3.7.1

=== src/webextension/Makefile ===
--- 
+++ 
@@ -1,15 +1,40 @@
 include ../../config.mk
 
 OBJ = $(patsubst %.c, %.lo, $(wildcard *.c))
+JSFILES = $(wildcard ../scripts/webext/*.js)
 
 all: $(EXTTARGET)
 
 clean:
 	$(RM) $(EXTTARGET) $(OBJ)
+	$(RM) js-snippets.h
 
 $(EXTTARGET): $(OBJ)
 	@echo "$(CC) $@"
 	$(Q)$(CC) $(OBJ) $(EXTLDFLAGS) -o $@
+
+$(OBJ): js-snippets.h
+
+js-snippets.h: $(JSFILES)
+	$(Q)$(RM) $@
+	@echo "create $@ from webextension scripts"
+	@echo "/**" > $@
+	@echo " * Minified JavaScript snippets for webextension DOM operations." >> $@
+	@echo " * Auto-generated by Makefile - DO NOT EDIT MANUALLY!" >> $@
+	@echo " * Generated from: $(JSFILES)" >> $@
+	@echo " * " >> $@
+	@echo " * To update: modify source .js files in src/scripts/webext/" >> $@
+	@echo " * Then run: make clean && make" >> $@
+	@echo " */" >> $@
+	@echo "" >> $@
+	@echo "#ifndef _JS_SNIPPETS_H" >> $@
+	@echo "#define _JS_SNIPPETS_H" >> $@
+	@echo "" >> $@
+	$(Q)for file in $(JSFILES); do \
+		../scripts/js2h.sh $$file >> $@; \
+	done
+	@echo "" >> $@
+	@echo "#endif /* _JS_SNIPPETS_H */" >> $@
 
 %.lo: %.c
 	@echo "${CC} $@"

=== debian/changelog ===
vimb (3.7.1-1) unstable; urgency=medium

  [ Mateusz Łukasik ]
  * New upstream release.
  * d/control:
    + Bump standards version to 4.7.3.
    + Drop Priority field
    + Drop Rules-Requires-Root field
  * Update d/watch to version 5.
  * Update d/copyright.
  * Drop debian/source/lintian-overrides
  * Switch Vcs to salsa.

  [ Nilesh Patra ]
  * Add patch for fix FTCBFS: hard-codes pkg-config (Closes: #1110406)

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Thu, 19 Feb 2026 18:16:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,11 @@
 Source: vimb
 Section: misc
-Priority: optional
 Maintainer: Mateusz Łukasik <mati75@linuxmint.pl>
 Build-Depends: debhelper-compat (= 13), libsoup-3.0-dev, libwebkit2gtk-4.1-dev, libgtk-3-dev, libglib2.0-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://fanglingsu.github.io/vimb/
-Vcs-Browser: https://github.com/mati75/vimb
-Vcs-Git: https://github.com/mati75/vimb
-Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/mati75/vimb.git
+Vcs-Git: https://salsa.debian.org/mati75/vimb.git
 
 Package: vimb
 Architecture: any

=== debian/watch ===
Version: 5
Template: Github
Owner: fanglingsu
Project: vimb
